/*
 * ChordNode.java
 */

package dhash;

/**
 * @author  Paul Jackson
 */

import java.rmi.Remote;
import java.rmi.RemoteException;


public interface ChordNode extends Remote {

    ID getID() throws RemoteException;

    ChordNodeRef getSuccessor() throws RemoteException;
    ChordNodeRef getPredecessor() throws RemoteException;
    ChordNodeRef getFinger(int i) throws RemoteException;

    void setPredecessor(ChordNodeRef n) throws RemoteException;
    
    ChordNodeRef findSuccessor(ID id) throws RemoteException;
    ChordNodeRef findStrictPredecessor(ID id) throws RemoteException;
    
    void updateFingerTable(ChordNodeRef s, int i) throws RemoteException;
    
    String toShortString() throws RemoteException;
    String toLongString() throws RemoteException;
    AppNode getAppNode() throws RemoteException;
    void processNewPredecessor() throws RemoteException;
    
}
   
