/*
 * DHashNode.java
 *
 */

package dhash;

import java.rmi.Remote;
import java.rmi.RemoteException;
import java.util.Map;

/**
 *
 * @author  Paul Jackson
 */
public interface DHashNode extends Remote {
    
    // For ChordNode access
    ChordNodeRef getChordNode() throws RemoteException;
    String getName() throws RemoteException;
    
    // For DHApp node access
    DHAppNode getDHAppNode() throws RemoteException;

    // local map operations
    void localPut(String key, Object value) throws RemoteException; 
    Object localGet(String key) throws RemoteException;
    boolean localContains(String key) throws RemoteException; 
    void localRemove(String key)  throws RemoteException; 

    void localDHAppGet(String key) throws RemoteException;

    // For debug only
    Map<String,Object> getLocalMap() throws RemoteException;
}
