package util;

import java.io.*;

import java.net.URL;

import java.nio.*;
import java.nio.channels.*;
import java.nio.charset.*;

import java.security.*;

import java.util.*;
import java.util.logging.Level;
import java.util.logging.Logger;


/**
 * DOCUMENT ME!
 *
 * @author $Author: axa $
 * @version $Rev: 65 $
 */
public class Util {
    //~ Static fields/initializers -------------------------------------------

    /** What character set should we use for communications? */
    public static final Charset charset = Charset.forName("US-ASCII");
    static CharsetDecoder decoder;
    static Logger logger;

    static {
        logger = Logger.getLogger("lib.Util");
        decoder = charset.newDecoder();
    }

    /** Size of a hash in Characters (this is an SHA-1 hash) */
    public static final int HASHSIZE = 28;

    /** What size should a buffer be when fist created? */
    public static final int BUFSIZE = 128;

    //~ Methods --------------------------------------------------------------

    /**
     * DOCUMENT ME!
     *
     * @param message DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     */
    public static byte[] digest(byte[] message) {
        logger.entering("lib.Digest", "digest", message);

        MessageDigest md;

        try {
            md = MessageDigest.getInstance("SHA");
        } catch(NoSuchAlgorithmException e) {
            e.printStackTrace();

            return null;
        }

        md.update(message);

        byte[] digest = md.digest();

        return digest;
    }

    /**
     * DOCUMENT ME!
     *
     * @param buf DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     */
    public static byte[] digest(ByteBuffer buf) {
        byte[] message = new byte[buf.remaining()];
        buf.get(message);

        return digest(message);
    }

    /**
     * DOCUMENT ME!
     *
     * @param str DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     */
    public static byte[] digest(String str) {
        return digest(str.getBytes());
    }

    /**
     * DOCUMENT ME!
     *
     * @param url DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     */
    public static byte[] digest(URL url) {
        return digest(url.toString());
    }
}
