/*
 * CNHandler.java
 *
 * @author Paul Jackson
 *
 * Logging handler for log records generated by tracing of methods in
 * ChordNodeImp class.
 * 
 */

package dhash;

import java.util.logging.*;
import java.rmi.RemoteException;

import util.AuxProcess;

//==EXTRA IMPORTS FOR SOLUTION ===============================================
//Keep this banner


public class CNHandler extends Handler {

    private static Formatter defaultFormatter = new SimpleFormatter();

    private static String nl = System.getProperty("line.separator");

    private Monitor monitor;  // Destination for publication of log records

    public CNHandler(Monitor monitor) {
        this.monitor = monitor;
    }
    public void close() {};
    public void flush() {};

    //== SOLUTION CODE =======================================================
    //Keep this banner
    //If any of above class members need modifying, please move them to below
    //this banner.

    public void publish(LogRecord record) {

        if (!isLoggable(record)) return;  

        try {
            monitor.publish(AuxProcess.getJVMName(),
                            "X",
                            defaultFormatter.format(record));
            
        } catch (RemoteException e) {
            e.printStackTrace();
        }
    }
}
