/**
 * 
 * CNSlave.java
 */
package dhash;

import java.rmi.Remote;
import java.rmi.RemoteException;

/**
 * @author Paul Jackson
 *
 */
public interface CNSlave extends Remote {

    // Methods for controlling ring structure
    void initForNewRing() throws RemoteException;
    void join(CNSlave nprime) throws RemoteException;
       
    // Main Chord protocol lookup method
    CNSlave findSuccessor(ID id) throws RemoteException; 

    // Debug methods
    String toLongString() throws RemoteException;

    // Slave utility methods
    ChordNodeRef getChordNode() throws RemoteException;
    ID getID() throws RemoteException;
        

}
