/*
 * DHNSlave.java
 *
 */

package dhash;

import java.rmi.Remote;
import java.rmi.RemoteException;

/**
 *
 * @author  pbj
 */

public interface DHNSlave extends Remote {
    
    // Methods for controlling ring structure
    void initForNewRing() throws RemoteException;
    void join(DHNSlave dHN) throws RemoteException;
    
    // HashMap methods
    void put(String key, Object value) throws RemoteException;
    Object get(String key) throws RemoteException;
    boolean contains(String key) throws RemoteException;
    void remove(String key) throws RemoteException;

    DHAppNode dHAppGet(String key) throws RemoteException;

    // Slave utility methods
    DHashNode getDHashNode() throws RemoteException;
}
